Loading...
Searching...
No Matches
wayland::registry_t Class Reference

global registry object More...

`#include <wayland-client-protocol.hpp>`

Inheritance diagram for wayland::registry_t:
[legend]
Collaboration diagram for wayland::registry_t:
[legend]

## Public Types

enum class | wrapper_type { standard , display , foreign , proxy_wrapper }

## Public Member Functions

proxy_t | bind (uint32_t name, proxy_t &interface, uint32_t version)
| bind an object to the display
std::function< void(uint32_t, std::string, uint32_t)> & | on_global ()
| announce global object
std::function< void(uint32_t)> & | on_global_remove ()
| announce removal of global object
uint32_t | get_id () const
| Get the id of a proxy object.
std::string | get_class () const
| Get the interface name (class) of a proxy object.
uint32_t | get_version () const
| Get the protocol object version of a proxy object.
wrapper_type | get_wrapper_type () const
| Get the type of a proxy object.
void | set_queue (event_queue_t queue)
| Assign a proxy to an event queue.
wl_proxy * | c_ptr () const
| Get a pointer to the underlying C struct.
bool | proxy_has_object () const
| Check whether this wrapper actually wraps an object.
| operator bool () const
| Check whether this wrapper actually wraps an object.
bool | operator== (const proxy_t &right) const
| Check whether two wrappers refer to the same object.
bool | operator!= (const proxy_t &right) const
| Check whether two wrappers refer to different objects.
void | proxy_release ()
| Release the wrapped object (if any), making this an empty wrapper.

## Static Public Attributes

static constexpr std::uint32_t | bind_since_version = 1
| Minimum protocol version required for the bind function.

## Detailed Description

global registry object

The singleton global registry object. The server has a number of global objects that are available to all clients. These objects typically represent an actual object in the server (for example, an input device) or they are singleton objects that provide extension functionality.

When a client creates a registry object, the registry object will emit a global event for each global currently in the registry. Globals come and go as a result of device or monitor hotplugs, reconfiguration or other events, and the registry will send out global and global_remove events to keep the client up to date with the changes. To mark the end of the initial burst of events, the client can use the wl_display.sync request immediately after calling wl_display.get_registry.

A client can bind to a global object by using the bind request. This creates a client-side handle that lets the object emit events to the client and lets the client invoke requests on the object.

Examples
  dump.cpp, egl.cpp, foreign_display.cpp, proxy_wrapper.cpp, and shm.cpp.

Definition at line 132 of file wayland-client-protocol.hpp.

## Member Enumeration Documentation

## wrapper_type

enum class wayland::proxy_t::wrapper_type

strong inherited

Underlying wl_proxy type and properties of a proxy_t that affect construction, destruction, and event handling

Enumerator
standard | C pointer is a standard type compatible with wl_proxy*. Events are dispatched and it is destructed when the proxy_t is destructed. User data is set.
display | C pointer is a wl_display*. No events are dispatched, wl_display_disconnect is called when the proxy_t is destructed. User data is set.

foreign

C pointer is a standard type compatible with wl_proxy*, but another library owns it and it should not be touched in a way that could affect the operation of the other library. No events are dispatched, wl_proxy_destroy is not called when the proxy_t is destructed, user data is not touched. Consequently, there is no reference counting for the proxy_t. Lifetime of such wrappers should preferably be short to minimize the chance that the owning library decides to destroy the wl_proxy.

proxy_wrapper | C pointer is a wl_proxy* that was constructed with wl_proxy_create_wrapper. No events are dispatched, wl_proxy_wrapper_destroy is called when the proxy_t is destroyed. Reference counting is active. A reference to the proxy_t creating this proxy wrapper is held to extend its lifetime until after the proxy wrapper is destroyed.

Definition at line 117 of file wayland-client.hpp.

## Member Function Documentation

## bind()

proxy_t registry_t::bind | ( | uint32_t | name,
|  | proxy_t & | interface,
|  | uint32_t | version
| ) |  |

bind an object to the display

Returns
  bounded object

Parameters

  name | unique numeric name of the object
  interface | Interface to bind
  version | Interface version

Binds a new, client-created object to the server using the specified name as the identifier.

Examples
  egl.cpp, proxy_wrapper.cpp, and shm.cpp.

Definition at line 1598 of file wayland-client-protocol.cpp.

## c_ptr()

wl_proxy * wayland::proxy_t::c_ptr | ( |  | ) | const

inherited

Get a pointer to the underlying C struct.

Returns
  The underlying wl_proxy wrapped by this proxy_t if it exists, otherwise an exception is thrown

## get_class()

std::string wayland::proxy_t::get_class | ( |  | ) | const

inherited

Get the interface name (class) of a proxy object.

Returns
  The interface name of the object associated with the proxy

## get_id()

uint32_t wayland::proxy_t::get_id | ( |  | ) | const

inherited

Get the id of a proxy object.

Returns
  The id the object associated with the proxy

## get_version()

uint32_t wayland::proxy_t::get_version | ( |  | ) | const

inherited

Get the protocol object version of a proxy object.

Gets the protocol object version of a proxy object, or 0 if the proxy was created with unversioned API.

A returned value of 0 means that no version information is available, so the caller must make safe assumptions about the object's real version.

display_t will always return version 0.

Returns
  The protocol object version of the proxy or 0

## get_wrapper_type()

wrapper_type wayland::proxy_t::get_wrapper_type | ( |  | ) | const

inline inherited

Get the type of a proxy object.

Definition at line 303 of file wayland-client.hpp.

## on_global()

std::function< void(uint32_t, std::string, uint32_t)> & registry_t::on_global | ( |  | ) |

announce global object

Parameters

  name | numeric name of the global object
  interface | interface implemented by the object
  version | interface version

Notify the client of global objects.

The event notifies the client that a global object with the given name is now available, and it implements the given version of the given interface.

Examples
  dump.cpp, egl.cpp, foreign_display.cpp, proxy_wrapper.cpp, and shm.cpp.

Definition at line 1606 of file wayland-client-protocol.cpp.

## on_global_remove()

std::function< void(uint32_t)> & registry_t::on_global_remove | ( |  | ) |

announce removal of global object

Parameters

  name | numeric name of the global object

Notify the client of removed global objects.

This event notifies the client that the global identified by name is no longer available. If the client bound to the global using the bind request, the client should now destroy that object.

The object remains valid and requests to the object will be ignored until the client destroys it, to avoid races between the global going away and a client sending a request to it.

Definition at line 1611 of file wayland-client-protocol.cpp.

## operator bool()

wayland::proxy_t::operator bool | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## operator!=()

bool wayland::proxy_t::operator!= | ( | const proxy_t & | right | ) | const

inherited

Check whether two wrappers refer to different objects.

## operator==()

bool wayland::proxy_t::operator== | ( | const proxy_t & | right | ) | const

inherited

Check whether two wrappers refer to the same object.

## proxy_has_object()

bool wayland::proxy_t::proxy_has_object | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## proxy_release()

void wayland::proxy_t::proxy_release | ( |  | ) |

inherited

Release the wrapped object (if any), making this an empty wrapper.

Note that display_t instances cannot be released this way. Attempts to do so are ignored.

Examples
  foreign_display.cpp.

## set_queue()

void wayland::proxy_t::set_queue | ( | event_queue_t | queue | ) |

inherited

Assign a proxy to an event queue.

Parameters

  queue | The event queue that will handle this proxy

Assign proxy to event queue. Events coming from proxy will be queued in queue instead of the display's main queue.

See also: display_t::dispatch_queue().

Examples
  proxy_wrapper.cpp.

## Member Data Documentation

## bind_since_version

constexpr std::uint32_t wayland::registry_t::bind_since_version = 1

static constexpr

Minimum protocol version required for the bind function.

Definition at line 170 of file wayland-client-protocol.hpp.

The documentation for this class was generated from the following files:

- obj-x86_64-linux-gnu/wayland-client-protocol.hpp
- obj-x86_64-linux-gnu/wayland-client-protocol.cpp
- obj-x86_64-linux-gnu/wayland-server-protocol.cpp